<?php
//----------------------------------------------------------------------------------------------------------------------------
// Set date time to Europe/London
    date_default_timezone_set("Europe/London");

//Set time and offset, this is important as it needs
//changing dependant on the timezone of the server
    $Time = date("H:i:s");
    $Date = date("d-m-Y");
    $Month = date("F");
    $Year = date("Y");
	
# Mysql Login info
define('DBTYPE','mysql');
define('DBHOST','localhost');
define('DBNAME','');
define('DBUSER','');
define('DBPASS','');

$mysqli = new mysqli(DBHOST, DBUSER, DBPASS, DBNAME);
if($mysqli->connect_errno > 0) {
	die('There has been an SQL error, if this problem persists please seek technical assistance...');
}

//Functions
function getUserIP()
{
  $client = @$_SERVER['HTTP_CLIENT_IP'];
  $forward = @$_SERVER['HTTP_X_FORWARDED_FOR'];
  $remote = $_SERVER['REMOTE_ADDR'];
  if (filter_var($client, FILTER_VALIDATE_IP)) {
    $ip = $client;
  } elseif (filter_var($forward, FILTER_VALIDATE_IP)) {
    $ip = $forward;
  } else {
    $ip = $remote;
  }
  return $ip;
}
//----------------------------------------------------------------------------------------------------------------------------

//----------------------------------------------------------------------------------------------------------------------------
//User configurable variables
$Excluded_Staff = Array();
$Excluded_Departments = Array();

$UserIP = getUserIP();
$staff_open_tickets = 0;
$closed_tickets = 0;
$closed_tickets_overall = 0;
$open_tickets = 0;
$reopen_tickets = 0;
$reopen_thanks_tickets = 0;
$overdue_tickets = 0;
$TotalTicketsOpened=0;
$TotalTicketsClosed=0;
$tickets_by_site=0;
$NameColour = "#f0f8ff";
$ClosedColour = "#ffffff";
$OpenColour = "#ffffff";
$reopenColour = "#ffffff";
$dept_NameColour = "#f0f8ff";
$dept_ClosedColour = "#ffffff";
$dept_OpenColour = "#ffffff";
$dept_reopenColour = "#ffffff";
$message_body = "";
$username_array = array();
$staff_id_array = array();
$department_name_array = array();
$department_id_array = array();
$i = 0;
$d = 0;

$dept_opened_tickets = 0;
$dept_current_open_tickets = 0;
$dept_closed_tickets = 0;
$dept_overdue_tickets = 0;
$dept_PercentClosed = 0;

$debug="";
$runtype = "";

//----------------------------------------------------------------------------------------------------------------------------
//Is there a get variable in the URL?
if (isset($_GET['debug'])) { $debug = $_GET["debug"]; }
if (isset($_GET['runtype'])) { $runtype = $_GET["runtype"]; } else { $runtype = "daily"; }
//----------------------------------------------------------------------------------------------------------------------------


//----------------------------------------------------------------------------------------------------------------------------
//calculate hours for run types
if ($runtype == 'daily') {$hours = '12';}
if ($runtype == 'weekly') {$hours = '108';}
if ($runtype == 'monthly') {$hours = '730';}
if ($runtype == 'quarterly') {$hours = '2190';}
if ($runtype == 'yearly') {$hours = '8760';}
//----------------------------------------------------------------------------------------------------------------------------

//Make the first letter of the run type upper case
$runtype = ucfirst($runtype);

//----------------------------------------------------------------------------------------------------------------------------

//----------------------------------------------------------------------------------------------------------------------------
//Draw the table header
$message_body .= "<B><U><font color=black>Ticket stats per technician</font></B></U></br>";
$message_body .= "<table border=1 id=table_css>
<tr bgcolor='#f0f8ff'>
<td align=center><font face=arial size=2 color=black><B>Name</B></font></td>
<td align=center><font face=arial size=2 color=black><B>Assigned</B></font></td>
<td align=center><font face=arial size=2 color=black><B>Closed</B></font></td>
<td align=center><font face=arial size=2 color=black><B>Closed %</B></font></td>
<td align=center><font face=arial size=2 color=black><B>Overall %</B></font></td>
<td align=center><font face=arial size=2 color=black><B>Currently Open</B></font></td>
<td align=center><font face=arial size=2 color=black><B>RO Total</B></font></td>
<td align=center><font face=arial size=2 color=black><B>RO Thanks</B></font></td>
<td align=center><font face=arial size=2 color=black><B>Overdue</B></font></td>

</tr>";
//----------------------------------------------------------------------------------------------------------------------------

//----------------------------------------------------------------------------------------------------------------------------
//Get the user id for each user and put them into a two arrays
if ($data = $mysqli->prepare("SELECT username, staff_id FROM ost_staff order by username ASC")) {
  $data->execute();
  $data->bind_result($username, $staff_id);
  while ($data->fetch()) {

    //Is the current user excluded from the report?
    if (in_array($username, $Excluded_Staff)) {
      //Skip the user
    } else {
      //put the data collected into arrays
      $username_array[count($username_array)] = $username;
      $staff_id_array[count($staff_id_array)] = $staff_id;
    } // Close if (in_array($username, $Excluded_Staff)) {
    } //Close while ($data->fetch()) {
    } else {
      //Report SQL Error
      $Message = "There has been an SQL error, if this problem persists please seek technical assistance...";
      $data->close();
    }
    //----------------------------------------------------------------------------------------------------------------------------


    //----------------------------------------------------------------------------------------------------------------------------
	//Get the full number of closed tickets to calculate each users % closed over all tickets
	//Get the amount of closed tickets
      if ($data = $mysqli->prepare("SELECT COUNT(ticket_id) FROM ost_ticket WHERE closed BETWEEN DATE_SUB(NOW(), INTERVAL ? HOUR) AND NOW()")) {
        $data->bind_param('i', $hours);
        $data->execute();
        $data->store_result();
        $data->bind_result($closed_tickets_overall);
        $data->fetch();
      } else {
        //Report SQL Error
        $Message = "There has been an SQL error, if this problem persists please seek technical assistance";
        $data->close();
      }
    //----------------------------------------------------------------------------------------------------------------------------



    //----------------------------------------------------------------------------------------------------------------------------
    //Loop through each user in the array and get their ticket details
    for ($i = 0; $i < count($username_array); $i++) {

      //Get the amount of created tickets and the open / close times
      if ($data = $mysqli->prepare("SELECT COUNT(ticket_id) FROM ost_ticket WHERE created BETWEEN DATE_SUB(NOW(), INTERVAL ? HOUR) AND NOW() AND staff_id = ?")) {
        $data->bind_param('ii', $hours, $staff_id_array[$i]);
        $data->execute();
        $data->store_result();
        $data->bind_result($open_tickets);
        $data->fetch();
      } else {
        //Report SQL Error
        $Message = "There has been an SQL error, if this problem persists please seek technical assistance";
        $data->close();
      }

      //Get the amount of closed tickets
      if ($data = $mysqli->prepare("SELECT COUNT(ticket_id) FROM ost_ticket WHERE closed BETWEEN DATE_SUB(NOW(), INTERVAL ? HOUR) AND NOW() AND staff_id = ?")) {
        $data->bind_param('ii', $hours, $staff_id_array[$i]);
        $data->execute();
        $data->store_result();
        $data->bind_result($closed_tickets);
        $data->fetch();
      } else {
        //Report SQL Error
        $Message = "There has been an SQL error, if this problem persists please seek technical assistance";
        $data->close();
      }

      //Get tickets that have been re-opended
      if ($data = $mysqli->prepare("SELECT COUNT(ticket_id) FROM ost_ticket WHERE reopened BETWEEN DATE_SUB(NOW(), INTERVAL ? HOUR) AND NOW() AND staff_id = ?")) {
        $data->bind_param('ii', $hours, $staff_id_array[$i]);
        $data->execute();
        $data->store_result();
        $data->bind_result($reopen_tickets);
        $data->fetch();
      } else {
        //Report SQL Error
        $Message = "There has been an SQL error, if this problem persists please seek technical assistance";
        $data->close();
      }

      //Get tickets that have been re-opended due to a thank you message
      if ($data = $mysqli->prepare("SELECT COUNT(ost_ticket.ticket_id) FROM ost_ticket JOIN ost_department ON ost_ticket.dept_id = ost_department.id JOIN ost_thread ON ost_ticket.ticket_id = ost_thread.object_id JOIN ost_thread_entry ON ost_thread.id = ost_thread_entry.thread_id WHERE ost_ticket.reopened BETWEEN DATE_SUB(NOW(), INTERVAL ? HOUR) AND NOW() AND ost_thread_entry.body LIKE 'Ticket re-closed due to thank you message.'  and ost_ticket.staff_id = ?")) {
        $data->bind_param('ii', $hours, $staff_id_array[$i]);
        $data->execute();
        $data->store_result();
        $data->bind_result($reopen_thanks_tickets);
        $data->fetch();

        //Calculate the amount of reopen_tickets minus the reopen_thanks_tickets
        if ($reopen_tickets > $reopen_thanks_tickets) {
          $reopen_tickets = $reopen_tickets - $reopen_thanks_tickets;
        }
      } else {
        //Report SQL Error
        $Message = "There has been an SQL error, if this problem persists please seek technical assistance";
        $data->close();
      }

      //Get tickets that are overdue
      if ($data = $mysqli->prepare("SELECT COUNT(ticket_id) FROM ost_ticket WHERE isoverdue = 1 AND staff_id = ?")) {
        $data->bind_param('i', $staff_id_array[$i]);
        $data->execute();
        $data->store_result();
        $data->bind_result($overdue_tickets);
        $data->fetch();
      } else {
        //Report SQL Error
        $Message = "There has been an SQL error, if this problem persists please seek technical assistance";
        $data->close();
      }

      //Get tickets that are open
      if ($data = $mysqli->prepare("SELECT COUNT(ticket_id) FROM ost_ticket WHERE closed IS NULL AND staff_id = ?")) {
        $data->bind_param('i', $staff_id_array[$i]);
        $data->execute();
        $data->store_result();
        $data->bind_result($staff_open_tickets);
        $data->fetch();
      } else {
        //Report SQL Error
        $Message = "There has been an SQL error, if this problem persists please seek technical assistance";
        $data->close();
      }

      //Calculate percentage of tickets closed vs opened
      if ($open_tickets > 0) {
        $PercentClosed = $closed_tickets / $open_tickets * 100;
        $PercentClosed = round($PercentClosed,2);
      }

      //Calculate percentage of tickets closed overall
      if ($open_tickets > 0) {
        $OverallPercentClosed = $closed_tickets / $closed_tickets_overall * 100;
        $OverallPercentClosed = round($OverallPercentClosed,2);
      }

      //Colour Coding for table cells
      if ($closed_tickets < $open_tickets) {$ClosedColour = "#ff0000";}
      if ($closed_tickets >= $open_tickets) {$ClosedColour = "#00ff00";}
      if ($reopen_tickets >= 1) {$reopenColour = "#ff9900";}
      if ($PercentClosed >= 100) {$PercentColour = "#00ff00";} else {$PercentColour = "#ff0000";}

      //Draw a table row for eacher user
      $message_body .= "<tr bgcolor=#ffffff>";
      $message_body .= "<td align=center bgcolor=" . $NameColour . "><font face=arial size=2 color=black><B>" . $username_array[$i] . "</B></td>";
      $message_body .= "<td align=center bgcolor=" . $OpenColour . "><font face=arial size=2 color=black>" . $open_tickets . "</td>";
      $message_body .= "<td align=center bgcolor=" . $ClosedColour . "><font face=arial size=2 color=black>" . $closed_tickets . "</td>";
      $message_body .= "";

      if ($open_tickets > 0) {
        $message_body .= "<td align=center bgcolor=" . $PercentColour . "><font face=arial size=2 color=black>" . $PercentClosed . "%</td>";
      } else {
        $message_body .= "<td align=center><font face=arial size=2 color=black></td>";
      }

	if ($open_tickets > 0) {
        $message_body .= "<td align=center><font face=arial size=2 color=black>" . $OverallPercentClosed . "%</td>";
      } else {
        $message_body .= "<td align=center><font face=arial size=2 color=black></td>";
      }

      $message_body .= "<td align=center><font face=arial size=2 color=black>" . $staff_open_tickets . "</td>";
      $message_body .= "<td align=center bgcolor=" . $reopenColour . "><font face=arial size=2 color=black>" . $reopen_tickets . "</td>";
      $message_body .= "<td align=center><font face=arial size=2 color=black>" . $reopen_thanks_tickets . "</td>";
      $message_body .= "<td align=center><font face=arial size=2 color=black>" . $overdue_tickets . "</td>";
      $message_body .= "</tr>";

      //Reset the colour coding and variables for the next user
      $NameColour = "#f0f8ff";
      $ClosedColour = "#ffffff";
      $OpenColour = "#ffffff";
      $reopenColour = "#ffffff";
      $total_open_time = 0;

      //Total Ticket Stats
      $CurrentlyOpen = $CurrentlyOpen + $staff_open_tickets;
      $TotalTicketsOpened = $TotalTicketsOpened + $open_tickets;
      $TotalTicketsClosed = $TotalTicketsClosed + $closed_tickets;
      $TotalTicketsOverdue = $TotalTicketsOverdue  + $overdue_tickets;
    } // Close for ($i = 0; $i < count($username_array); $i++) {
      //----------------------------------------------------------------------------------------------------------------------------

      //----------------------------------------------------------------------------------------------------------------------------
      //Close the table off
      $message_body .= "</table><P>";


      $message_body .= "<B><U>Overall Statistics for technicians</B></U></br>";
      $message_body .= "Currently Open: " . $CurrentlyOpen . "</br>";
      $message_body .= "Total Opened: " . $TotalTicketsOpened . "</br>";
      $message_body .= "Total Closed: " . $TotalTicketsClosed . "</br>";

      //Calculate the total percentage closed
      $PercentClosed = $TotalTicketsClosed / $TotalTicketsOpened * 100;
      $PercentClosed = round($PercentClosed,2);

      //Colour Coding for stats
      if ($PercentClosed < 100) {$PercentClosedColour = "#ff0000";}
      if ($PercentClosed >= 100) {$PercentClosedColour = "#00ff00";}


      //Add to message body for email
      $message_body .= "Closed: <font color=" . $PercentClosedColour . ">" . $PercentClosed . "%<p></font>";
      //----------------------------------------------------------------------------------------------------------------------------


      //----------------------------------------------------------------------------------------------------------------------------
      //Draw the table header
      $message_body .= "<B><U><font color=black>Ticket stats per site</font></B></U></br>";
      $message_body .= "<table border=1 id=table_css>
      <tr bgcolor='#f0f8ff'>
      <td align=center><font face=arial size=2 color=black><B>Site</B></font></td>
      <td align=center><font face=arial size=2 color=black><B>Opended</B></font></td>
      <td align=center><font face=arial size=2 color=black><B>Closed</B></font></td>
      <td align=center><font face=arial size=2 color=black><B>% Closed</B></font></td>
      <td align=center><font face=arial size=2 color=black><B>Currently Open</B></font></td>
      <td align=center><font face=arial size=2 color=black><B>Overdue</B></font></td>

      </tr>";
      //----------------------------------------------------------------------------------------------------------------------------

      //----------------------------------------------------------------------------------------------------------------------------
      //Get the dept id for each site and put them into a two arrays
      if ($data = $mysqli->prepare("SELECT name, id FROM ost_department order by name ASC")) {
        $data->execute();
        $data->bind_result($department_name, $department_id);
        while ($data->fetch()) {

          //Is the current user excluded from the report?
          if (in_array($department_name, $Excluded_Departments)) {
            //Skip the user
          } else {

            //put the data collected into arrays
            $department_name_array[count($department_name_array)] = $department_name;
            $department_id_array[count($department_id_array)] = $department_id;

          }
        }
      } else {
        //Report SQL Error
        $Message = "There has been an SQL error, if this problem persists please seek technical assistance";
        $data->close();
      }
      //----------------------------------------------------------------------------------------------------------------------------

      //----------------------------------------------------------------------------------------------------------------------------
      //Loop through each user in the array and get their ticket details
      for ($d = 0; $d < count($department_name_array); $d++) {

        //Get the amount of created tickets over the given time period
        if ($data = $mysqli->prepare("SELECT COUNT(ticket_id) FROM ost_ticket WHERE created BETWEEN DATE_SUB(NOW(), INTERVAL ? HOUR) AND NOW() AND dept_id = ?")) {
          $data->bind_param('ii', $hours, $department_id_array[$d]);
          $data->execute();
          $data->store_result();
          $data->bind_result($dept_opened_tickets);
          $data->fetch();
        } else {
          //Report SQL Error
          $Message = "There has been an SQL error, if this problem persists please seek technical assistance";
          $data->close();
        }

        //Get the amount of created tickets and the open / close times
        if ($data = $mysqli->prepare("SELECT COUNT(ticket_id) FROM ost_ticket WHERE closed BETWEEN DATE_SUB(NOW(), INTERVAL ? HOUR) AND NOW() AND dept_id = ?")) {
          $data->bind_param('ii', $hours, $department_id_array[$d]);
          $data->execute();
          $data->store_result();
          $data->bind_result($dept_closed_tickets);
          $data->fetch();
        } else {
          //Report SQL Error
          $Message = "There has been an SQL error, if this problem persists please seek technical assistance";
          $data->close();
        }

        //Get tickets that are overdue
        if ($data = $mysqli->prepare("SELECT COUNT(ticket_id) FROM ost_ticket WHERE isoverdue = 1 AND dept_id = ?")) {
          $data->bind_param('i', $department_id_array[$d]);
          $data->execute();
          $data->store_result();
          $data->bind_result($dept_overdue_tickets);
          $data->fetch();
        } else {
          //Report SQL Error
          $Message = "There has been an SQL error, if this problem persists please seek technical assistance";
          $data->close();
        }

        //Get tickets that are open
        if ($data = $mysqli->prepare("SELECT COUNT(ticket_id) FROM ost_ticket WHERE closed IS NULL AND dept_id = ?")) {
          $data->bind_param('i', $department_id_array[$d]);
          $data->execute();
          $data->store_result();
          $data->bind_result($dept_current_open_tickets);
          $data->fetch();
        } else {
          //Report SQL Error
          $Message = "There has been an SQL error, if this problem persists please seek technical assistance";
          $data->close();
        }

        //Calculate percentage of tickets closed vs opened
        if ($dept_opened_tickets > 0) {
          $dept_PercentClosed = $dept_closed_tickets / $dept_opened_tickets * 100;
          $dept_PercentClosed = round($dept_PercentClosed,2);
        }

        //Colour Coding for table cells
        if ($dept_closed_tickets < $dept_opened_tickets) {$dept_ClosedColour = "#ff0000";} //RED - Less tickets closed than opened
        if ($dept_closed_tickets >= $dept_opened_tickets) {$dept_ClosedColour = "#00ff00";} //GREEN - More tickets closed then opened
        if ($dept_current_open_tickets >= 10) {$dept_CurrentOpenColour = "#ff9900";} //ORANGE - More than 10 tickets currently open
        if ($dept_PercentClosed >= 100) {$dept_PercentColour = "#00ff00";} else {$dept_PercentColour = "#ff0000";}

        //Draw a table row for each site
        $message_body .= "<tr bgcolor=#ffffff>";
        $message_body .= "<td align=center bgcolor=" . $dept_NameColour . "><font face=arial size=2 color=black><B>" . $department_name_array[$d] . "</B></td>";
        $message_body .= "<td align=center bgcolor=" . $dept_OpenColour . "><font face=arial size=2 color=black>" . $dept_opened_tickets . "</td>";
        $message_body .= "<td align=center bgcolor=" . $dept_ClosedColour . "><font face=arial size=2 color=black>" . $dept_closed_tickets . "</td>";


        if ($dept_opened_tickets > 0) {
          $message_body .= "<td align=center bgcolor=" . $dept_PercentColour . "><font face=arial size=2 color=black>" . $dept_PercentClosed . "%</td>";
        } else {
          $message_body .= "<td align=center><font face=arial size=2 color=black></td>";
        }

        $message_body .= "<td align=center bgcolor=" . $dept_CurrentOpenColour . "><font face=arial size=2 color=black>" . $dept_current_open_tickets . "</td>";
        $message_body .= "";

        $message_body .= "<td align=center><font face=arial size=2 color=black>" . $dept_overdue_tickets . "</td>";
        $message_body .= "</tr>";


        //Reset the colour coding and variables for the next user
        $dept_NameColour = "#f0f8ff";
        $dept_ClosedColour = "#ffffff";
        $dept_OpenColour = "#ffffff";
        $dept_CurrentOpenColour = "#ffffff";
        $dept_total_open_time = 0;

      }
      //----------------------------------------------------------------------------------------------------------------------------

      //----------------------------------------------------------------------------------------------------------------------------
      //Close the table off
      $message_body .= "</table><P>";
      //----------------------------------------------------------------------------------------------------------------------------

      //----------------------------------------------------------------------------------------------------------------------------
	//Send emails if debug is not enabled
	if ($debug == "y") {
	echo "email not sent!<p>";
		} else {
      			// Always set content-type when sending HTML email
     			$headers = "MIME-Version: 1.0" . "\r\n";
      			$headers .= "Content-type:text/html;charset=UTF-8" . "\r\n";

        		$success = mail('you@yourdomain.com', 'Helpdesk Stats', $message_body, $headers);
           		if (!$success) {
            			$errorMessage = error_get_last()['message'];
        		} else {
            			echo "email sent!<p>";
        		}
		}

      //----------------------------------------------------------------------------------------------------------------------------
      //echo out to the user
      echo $message_body;
      //----------------------------------------------------------------------------------------------------------------------------
